/**
 * file src/libtarot/cards/tarot/cards_private_impl.h
 * This file has been generated from src/libtarot/cards/cards.xsl.
 */
#ifndef H_TAROT_CARDS_PRIVATE_IMPL_INCLUDED
#define H_TAROT_CARDS_PRIVATE_IMPL_INCLUDED
#include <stddef.h>
#include <tarot/cards_private.h>
#include <string.h>
#include <assert.h>
#include <gettext.h>
#define _(String) dgettext (PACKAGE, String)

static inline int
of (TarotNumber n, TarotSuit s, TarotCard * c)
{
  if (n == TAROT_ACE && s == TAROT_HEARTS)
    {
      *c = 0;
      return 0;
    }
  if (n == 2 && s == TAROT_HEARTS)
    {
      *c = 1;
      return 0;
    }
  if (n == 3 && s == TAROT_HEARTS)
    {
      *c = 2;
      return 0;
    }
  if (n == 4 && s == TAROT_HEARTS)
    {
      *c = 3;
      return 0;
    }
  if (n == 5 && s == TAROT_HEARTS)
    {
      *c = 4;
      return 0;
    }
  if (n == 6 && s == TAROT_HEARTS)
    {
      *c = 5;
      return 0;
    }
  if (n == 7 && s == TAROT_HEARTS)
    {
      *c = 6;
      return 0;
    }
  if (n == 8 && s == TAROT_HEARTS)
    {
      *c = 7;
      return 0;
    }
  if (n == 9 && s == TAROT_HEARTS)
    {
      *c = 8;
      return 0;
    }
  if (n == 10 && s == TAROT_HEARTS)
    {
      *c = 9;
      return 0;
    }
  if (n == TAROT_JACK && s == TAROT_HEARTS)
    {
      *c = 10;
      return 0;
    }
  if (n == TAROT_KNIGHT && s == TAROT_HEARTS)
    {
      *c = 11;
      return 0;
    }
  if (n == TAROT_QUEEN && s == TAROT_HEARTS)
    {
      *c = 12;
      return 0;
    }
  if (n == TAROT_KING && s == TAROT_HEARTS)
    {
      *c = 13;
      return 0;
    }
  if (n == TAROT_ACE && s == TAROT_CLUBS)
    {
      *c = 14;
      return 0;
    }
  if (n == 2 && s == TAROT_CLUBS)
    {
      *c = 15;
      return 0;
    }
  if (n == 3 && s == TAROT_CLUBS)
    {
      *c = 16;
      return 0;
    }
  if (n == 4 && s == TAROT_CLUBS)
    {
      *c = 17;
      return 0;
    }
  if (n == 5 && s == TAROT_CLUBS)
    {
      *c = 18;
      return 0;
    }
  if (n == 6 && s == TAROT_CLUBS)
    {
      *c = 19;
      return 0;
    }
  if (n == 7 && s == TAROT_CLUBS)
    {
      *c = 20;
      return 0;
    }
  if (n == 8 && s == TAROT_CLUBS)
    {
      *c = 21;
      return 0;
    }
  if (n == 9 && s == TAROT_CLUBS)
    {
      *c = 22;
      return 0;
    }
  if (n == 10 && s == TAROT_CLUBS)
    {
      *c = 23;
      return 0;
    }
  if (n == TAROT_JACK && s == TAROT_CLUBS)
    {
      *c = 24;
      return 0;
    }
  if (n == TAROT_KNIGHT && s == TAROT_CLUBS)
    {
      *c = 25;
      return 0;
    }
  if (n == TAROT_QUEEN && s == TAROT_CLUBS)
    {
      *c = 26;
      return 0;
    }
  if (n == TAROT_KING && s == TAROT_CLUBS)
    {
      *c = 27;
      return 0;
    }
  if (n == TAROT_ACE && s == TAROT_DIAMONDS)
    {
      *c = 28;
      return 0;
    }
  if (n == 2 && s == TAROT_DIAMONDS)
    {
      *c = 29;
      return 0;
    }
  if (n == 3 && s == TAROT_DIAMONDS)
    {
      *c = 30;
      return 0;
    }
  if (n == 4 && s == TAROT_DIAMONDS)
    {
      *c = 31;
      return 0;
    }
  if (n == 5 && s == TAROT_DIAMONDS)
    {
      *c = 32;
      return 0;
    }
  if (n == 6 && s == TAROT_DIAMONDS)
    {
      *c = 33;
      return 0;
    }
  if (n == 7 && s == TAROT_DIAMONDS)
    {
      *c = 34;
      return 0;
    }
  if (n == 8 && s == TAROT_DIAMONDS)
    {
      *c = 35;
      return 0;
    }
  if (n == 9 && s == TAROT_DIAMONDS)
    {
      *c = 36;
      return 0;
    }
  if (n == 10 && s == TAROT_DIAMONDS)
    {
      *c = 37;
      return 0;
    }
  if (n == TAROT_JACK && s == TAROT_DIAMONDS)
    {
      *c = 38;
      return 0;
    }
  if (n == TAROT_KNIGHT && s == TAROT_DIAMONDS)
    {
      *c = 39;
      return 0;
    }
  if (n == TAROT_QUEEN && s == TAROT_DIAMONDS)
    {
      *c = 40;
      return 0;
    }
  if (n == TAROT_KING && s == TAROT_DIAMONDS)
    {
      *c = 41;
      return 0;
    }
  if (n == TAROT_ACE && s == TAROT_SPADES)
    {
      *c = 42;
      return 0;
    }
  if (n == 2 && s == TAROT_SPADES)
    {
      *c = 43;
      return 0;
    }
  if (n == 3 && s == TAROT_SPADES)
    {
      *c = 44;
      return 0;
    }
  if (n == 4 && s == TAROT_SPADES)
    {
      *c = 45;
      return 0;
    }
  if (n == 5 && s == TAROT_SPADES)
    {
      *c = 46;
      return 0;
    }
  if (n == 6 && s == TAROT_SPADES)
    {
      *c = 47;
      return 0;
    }
  if (n == 7 && s == TAROT_SPADES)
    {
      *c = 48;
      return 0;
    }
  if (n == 8 && s == TAROT_SPADES)
    {
      *c = 49;
      return 0;
    }
  if (n == 9 && s == TAROT_SPADES)
    {
      *c = 50;
      return 0;
    }
  if (n == 10 && s == TAROT_SPADES)
    {
      *c = 51;
      return 0;
    }
  if (n == TAROT_JACK && s == TAROT_SPADES)
    {
      *c = 52;
      return 0;
    }
  if (n == TAROT_KNIGHT && s == TAROT_SPADES)
    {
      *c = 53;
      return 0;
    }
  if (n == TAROT_QUEEN && s == TAROT_SPADES)
    {
      *c = 54;
      return 0;
    }
  if (n == TAROT_KING && s == TAROT_SPADES)
    {
      *c = 55;
      return 0;
    }
  if (n == 1 && s == TAROT_TRUMPS)
    {
      *c = TAROT_PETIT;
      return 0;
    }
  if (n == 2 && s == TAROT_TRUMPS)
    {
      *c = 57;
      return 0;
    }
  if (n == 3 && s == TAROT_TRUMPS)
    {
      *c = 58;
      return 0;
    }
  if (n == 4 && s == TAROT_TRUMPS)
    {
      *c = 59;
      return 0;
    }
  if (n == 5 && s == TAROT_TRUMPS)
    {
      *c = 60;
      return 0;
    }
  if (n == 6 && s == TAROT_TRUMPS)
    {
      *c = 61;
      return 0;
    }
  if (n == 7 && s == TAROT_TRUMPS)
    {
      *c = 62;
      return 0;
    }
  if (n == 8 && s == TAROT_TRUMPS)
    {
      *c = 63;
      return 0;
    }
  if (n == 9 && s == TAROT_TRUMPS)
    {
      *c = 64;
      return 0;
    }
  if (n == 10 && s == TAROT_TRUMPS)
    {
      *c = 65;
      return 0;
    }
  if (n == 11 && s == TAROT_TRUMPS)
    {
      *c = 66;
      return 0;
    }
  if (n == 12 && s == TAROT_TRUMPS)
    {
      *c = 67;
      return 0;
    }
  if (n == 13 && s == TAROT_TRUMPS)
    {
      *c = 68;
      return 0;
    }
  if (n == 14 && s == TAROT_TRUMPS)
    {
      *c = 69;
      return 0;
    }
  if (n == 15 && s == TAROT_TRUMPS)
    {
      *c = 70;
      return 0;
    }
  if (n == 16 && s == TAROT_TRUMPS)
    {
      *c = 71;
      return 0;
    }
  if (n == 17 && s == TAROT_TRUMPS)
    {
      *c = 72;
      return 0;
    }
  if (n == 18 && s == TAROT_TRUMPS)
    {
      *c = 73;
      return 0;
    }
  if (n == 19 && s == TAROT_TRUMPS)
    {
      *c = 74;
      return 0;
    }
  if (n == 20 && s == TAROT_TRUMPS)
    {
      *c = 75;
      return 0;
    }
  if (n == 21 && s == TAROT_TRUMPS)
    {
      *c = TAROT_TWENTYONE;
      return 0;
    }
  return 1;
}

static inline int
decompose (TarotCard c, TarotNumber * n, TarotSuit * s)
{
  if (c == 0)
    {
      *n = TAROT_ACE;
      *s = TAROT_HEARTS;
      return 0;
    }
  if (c == 1)
    {
      *n = 2;
      *s = TAROT_HEARTS;
      return 0;
    }
  if (c == 2)
    {
      *n = 3;
      *s = TAROT_HEARTS;
      return 0;
    }
  if (c == 3)
    {
      *n = 4;
      *s = TAROT_HEARTS;
      return 0;
    }
  if (c == 4)
    {
      *n = 5;
      *s = TAROT_HEARTS;
      return 0;
    }
  if (c == 5)
    {
      *n = 6;
      *s = TAROT_HEARTS;
      return 0;
    }
  if (c == 6)
    {
      *n = 7;
      *s = TAROT_HEARTS;
      return 0;
    }
  if (c == 7)
    {
      *n = 8;
      *s = TAROT_HEARTS;
      return 0;
    }
  if (c == 8)
    {
      *n = 9;
      *s = TAROT_HEARTS;
      return 0;
    }
  if (c == 9)
    {
      *n = 10;
      *s = TAROT_HEARTS;
      return 0;
    }
  if (c == 10)
    {
      *n = TAROT_JACK;
      *s = TAROT_HEARTS;
      return 0;
    }
  if (c == 11)
    {
      *n = TAROT_KNIGHT;
      *s = TAROT_HEARTS;
      return 0;
    }
  if (c == 12)
    {
      *n = TAROT_QUEEN;
      *s = TAROT_HEARTS;
      return 0;
    }
  if (c == 13)
    {
      *n = TAROT_KING;
      *s = TAROT_HEARTS;
      return 0;
    }
  if (c == 14)
    {
      *n = TAROT_ACE;
      *s = TAROT_CLUBS;
      return 0;
    }
  if (c == 15)
    {
      *n = 2;
      *s = TAROT_CLUBS;
      return 0;
    }
  if (c == 16)
    {
      *n = 3;
      *s = TAROT_CLUBS;
      return 0;
    }
  if (c == 17)
    {
      *n = 4;
      *s = TAROT_CLUBS;
      return 0;
    }
  if (c == 18)
    {
      *n = 5;
      *s = TAROT_CLUBS;
      return 0;
    }
  if (c == 19)
    {
      *n = 6;
      *s = TAROT_CLUBS;
      return 0;
    }
  if (c == 20)
    {
      *n = 7;
      *s = TAROT_CLUBS;
      return 0;
    }
  if (c == 21)
    {
      *n = 8;
      *s = TAROT_CLUBS;
      return 0;
    }
  if (c == 22)
    {
      *n = 9;
      *s = TAROT_CLUBS;
      return 0;
    }
  if (c == 23)
    {
      *n = 10;
      *s = TAROT_CLUBS;
      return 0;
    }
  if (c == 24)
    {
      *n = TAROT_JACK;
      *s = TAROT_CLUBS;
      return 0;
    }
  if (c == 25)
    {
      *n = TAROT_KNIGHT;
      *s = TAROT_CLUBS;
      return 0;
    }
  if (c == 26)
    {
      *n = TAROT_QUEEN;
      *s = TAROT_CLUBS;
      return 0;
    }
  if (c == 27)
    {
      *n = TAROT_KING;
      *s = TAROT_CLUBS;
      return 0;
    }
  if (c == 28)
    {
      *n = TAROT_ACE;
      *s = TAROT_DIAMONDS;
      return 0;
    }
  if (c == 29)
    {
      *n = 2;
      *s = TAROT_DIAMONDS;
      return 0;
    }
  if (c == 30)
    {
      *n = 3;
      *s = TAROT_DIAMONDS;
      return 0;
    }
  if (c == 31)
    {
      *n = 4;
      *s = TAROT_DIAMONDS;
      return 0;
    }
  if (c == 32)
    {
      *n = 5;
      *s = TAROT_DIAMONDS;
      return 0;
    }
  if (c == 33)
    {
      *n = 6;
      *s = TAROT_DIAMONDS;
      return 0;
    }
  if (c == 34)
    {
      *n = 7;
      *s = TAROT_DIAMONDS;
      return 0;
    }
  if (c == 35)
    {
      *n = 8;
      *s = TAROT_DIAMONDS;
      return 0;
    }
  if (c == 36)
    {
      *n = 9;
      *s = TAROT_DIAMONDS;
      return 0;
    }
  if (c == 37)
    {
      *n = 10;
      *s = TAROT_DIAMONDS;
      return 0;
    }
  if (c == 38)
    {
      *n = TAROT_JACK;
      *s = TAROT_DIAMONDS;
      return 0;
    }
  if (c == 39)
    {
      *n = TAROT_KNIGHT;
      *s = TAROT_DIAMONDS;
      return 0;
    }
  if (c == 40)
    {
      *n = TAROT_QUEEN;
      *s = TAROT_DIAMONDS;
      return 0;
    }
  if (c == 41)
    {
      *n = TAROT_KING;
      *s = TAROT_DIAMONDS;
      return 0;
    }
  if (c == 42)
    {
      *n = TAROT_ACE;
      *s = TAROT_SPADES;
      return 0;
    }
  if (c == 43)
    {
      *n = 2;
      *s = TAROT_SPADES;
      return 0;
    }
  if (c == 44)
    {
      *n = 3;
      *s = TAROT_SPADES;
      return 0;
    }
  if (c == 45)
    {
      *n = 4;
      *s = TAROT_SPADES;
      return 0;
    }
  if (c == 46)
    {
      *n = 5;
      *s = TAROT_SPADES;
      return 0;
    }
  if (c == 47)
    {
      *n = 6;
      *s = TAROT_SPADES;
      return 0;
    }
  if (c == 48)
    {
      *n = 7;
      *s = TAROT_SPADES;
      return 0;
    }
  if (c == 49)
    {
      *n = 8;
      *s = TAROT_SPADES;
      return 0;
    }
  if (c == 50)
    {
      *n = 9;
      *s = TAROT_SPADES;
      return 0;
    }
  if (c == 51)
    {
      *n = 10;
      *s = TAROT_SPADES;
      return 0;
    }
  if (c == 52)
    {
      *n = TAROT_JACK;
      *s = TAROT_SPADES;
      return 0;
    }
  if (c == 53)
    {
      *n = TAROT_KNIGHT;
      *s = TAROT_SPADES;
      return 0;
    }
  if (c == 54)
    {
      *n = TAROT_QUEEN;
      *s = TAROT_SPADES;
      return 0;
    }
  if (c == 55)
    {
      *n = TAROT_KING;
      *s = TAROT_SPADES;
      return 0;
    }
  if (c == TAROT_PETIT)
    {
      *n = 1;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 57)
    {
      *n = 2;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 58)
    {
      *n = 3;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 59)
    {
      *n = 4;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 60)
    {
      *n = 5;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 61)
    {
      *n = 6;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 62)
    {
      *n = 7;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 63)
    {
      *n = 8;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 64)
    {
      *n = 9;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 65)
    {
      *n = 10;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 66)
    {
      *n = 11;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 67)
    {
      *n = 12;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 68)
    {
      *n = 13;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 69)
    {
      *n = 14;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 70)
    {
      *n = 15;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 71)
    {
      *n = 16;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 72)
    {
      *n = 17;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 73)
    {
      *n = 18;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 74)
    {
      *n = 19;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == 75)
    {
      *n = 20;
      *s = TAROT_TRUMPS;
      return 0;
    }
  if (c == TAROT_TWENTYONE)
    {
      *n = 21;
      *s = TAROT_TRUMPS;
      return 0;
    }
  return 1;
}

static inline TarotCard
card_parse (const char *text, char **end)
{
  size_t len = strlen (text);
  char *name_AH = _("AH");
  if (len >= strlen (name_AH)
      && strncmp (text, name_AH, strlen (name_AH)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_AH);
	}
      return 0;
    }
  char *name_2H = _("2H");
  if (len >= strlen (name_2H)
      && strncmp (text, name_2H, strlen (name_2H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_2H);
	}
      return 1;
    }
  char *name_3H = _("3H");
  if (len >= strlen (name_3H)
      && strncmp (text, name_3H, strlen (name_3H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_3H);
	}
      return 2;
    }
  char *name_4H = _("4H");
  if (len >= strlen (name_4H)
      && strncmp (text, name_4H, strlen (name_4H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_4H);
	}
      return 3;
    }
  char *name_5H = _("5H");
  if (len >= strlen (name_5H)
      && strncmp (text, name_5H, strlen (name_5H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_5H);
	}
      return 4;
    }
  char *name_6H = _("6H");
  if (len >= strlen (name_6H)
      && strncmp (text, name_6H, strlen (name_6H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_6H);
	}
      return 5;
    }
  char *name_7H = _("7H");
  if (len >= strlen (name_7H)
      && strncmp (text, name_7H, strlen (name_7H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_7H);
	}
      return 6;
    }
  char *name_8H = _("8H");
  if (len >= strlen (name_8H)
      && strncmp (text, name_8H, strlen (name_8H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_8H);
	}
      return 7;
    }
  char *name_9H = _("9H");
  if (len >= strlen (name_9H)
      && strncmp (text, name_9H, strlen (name_9H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_9H);
	}
      return 8;
    }
  char *name_10H = _("10H");
  if (len >= strlen (name_10H)
      && strncmp (text, name_10H, strlen (name_10H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_10H);
	}
      return 9;
    }
  char *name_JH = _("JH");
  if (len >= strlen (name_JH)
      && strncmp (text, name_JH, strlen (name_JH)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_JH);
	}
      return 10;
    }
  char *name_CH = _("CH");
  if (len >= strlen (name_CH)
      && strncmp (text, name_CH, strlen (name_CH)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_CH);
	}
      return 11;
    }
  char *name_QH = _("QH");
  if (len >= strlen (name_QH)
      && strncmp (text, name_QH, strlen (name_QH)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_QH);
	}
      return 12;
    }
  char *name_KH = _("KH");
  if (len >= strlen (name_KH)
      && strncmp (text, name_KH, strlen (name_KH)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_KH);
	}
      return 13;
    }
  char *name_AC = _("AC");
  if (len >= strlen (name_AC)
      && strncmp (text, name_AC, strlen (name_AC)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_AC);
	}
      return 14;
    }
  char *name_2C = _("2C");
  if (len >= strlen (name_2C)
      && strncmp (text, name_2C, strlen (name_2C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_2C);
	}
      return 15;
    }
  char *name_3C = _("3C");
  if (len >= strlen (name_3C)
      && strncmp (text, name_3C, strlen (name_3C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_3C);
	}
      return 16;
    }
  char *name_4C = _("4C");
  if (len >= strlen (name_4C)
      && strncmp (text, name_4C, strlen (name_4C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_4C);
	}
      return 17;
    }
  char *name_5C = _("5C");
  if (len >= strlen (name_5C)
      && strncmp (text, name_5C, strlen (name_5C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_5C);
	}
      return 18;
    }
  char *name_6C = _("6C");
  if (len >= strlen (name_6C)
      && strncmp (text, name_6C, strlen (name_6C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_6C);
	}
      return 19;
    }
  char *name_7C = _("7C");
  if (len >= strlen (name_7C)
      && strncmp (text, name_7C, strlen (name_7C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_7C);
	}
      return 20;
    }
  char *name_8C = _("8C");
  if (len >= strlen (name_8C)
      && strncmp (text, name_8C, strlen (name_8C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_8C);
	}
      return 21;
    }
  char *name_9C = _("9C");
  if (len >= strlen (name_9C)
      && strncmp (text, name_9C, strlen (name_9C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_9C);
	}
      return 22;
    }
  char *name_10C = _("10C");
  if (len >= strlen (name_10C)
      && strncmp (text, name_10C, strlen (name_10C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_10C);
	}
      return 23;
    }
  char *name_JC = _("JC");
  if (len >= strlen (name_JC)
      && strncmp (text, name_JC, strlen (name_JC)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_JC);
	}
      return 24;
    }
  char *name_CC = _("CC");
  if (len >= strlen (name_CC)
      && strncmp (text, name_CC, strlen (name_CC)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_CC);
	}
      return 25;
    }
  char *name_QC = _("QC");
  if (len >= strlen (name_QC)
      && strncmp (text, name_QC, strlen (name_QC)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_QC);
	}
      return 26;
    }
  char *name_KC = _("KC");
  if (len >= strlen (name_KC)
      && strncmp (text, name_KC, strlen (name_KC)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_KC);
	}
      return 27;
    }
  char *name_AD = _("AD");
  if (len >= strlen (name_AD)
      && strncmp (text, name_AD, strlen (name_AD)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_AD);
	}
      return 28;
    }
  char *name_2D = _("2D");
  if (len >= strlen (name_2D)
      && strncmp (text, name_2D, strlen (name_2D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_2D);
	}
      return 29;
    }
  char *name_3D = _("3D");
  if (len >= strlen (name_3D)
      && strncmp (text, name_3D, strlen (name_3D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_3D);
	}
      return 30;
    }
  char *name_4D = _("4D");
  if (len >= strlen (name_4D)
      && strncmp (text, name_4D, strlen (name_4D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_4D);
	}
      return 31;
    }
  char *name_5D = _("5D");
  if (len >= strlen (name_5D)
      && strncmp (text, name_5D, strlen (name_5D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_5D);
	}
      return 32;
    }
  char *name_6D = _("6D");
  if (len >= strlen (name_6D)
      && strncmp (text, name_6D, strlen (name_6D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_6D);
	}
      return 33;
    }
  char *name_7D = _("7D");
  if (len >= strlen (name_7D)
      && strncmp (text, name_7D, strlen (name_7D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_7D);
	}
      return 34;
    }
  char *name_8D = _("8D");
  if (len >= strlen (name_8D)
      && strncmp (text, name_8D, strlen (name_8D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_8D);
	}
      return 35;
    }
  char *name_9D = _("9D");
  if (len >= strlen (name_9D)
      && strncmp (text, name_9D, strlen (name_9D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_9D);
	}
      return 36;
    }
  char *name_10D = _("10D");
  if (len >= strlen (name_10D)
      && strncmp (text, name_10D, strlen (name_10D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_10D);
	}
      return 37;
    }
  char *name_JD = _("JD");
  if (len >= strlen (name_JD)
      && strncmp (text, name_JD, strlen (name_JD)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_JD);
	}
      return 38;
    }
  char *name_CD = _("CD");
  if (len >= strlen (name_CD)
      && strncmp (text, name_CD, strlen (name_CD)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_CD);
	}
      return 39;
    }
  char *name_QD = _("QD");
  if (len >= strlen (name_QD)
      && strncmp (text, name_QD, strlen (name_QD)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_QD);
	}
      return 40;
    }
  char *name_KD = _("KD");
  if (len >= strlen (name_KD)
      && strncmp (text, name_KD, strlen (name_KD)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_KD);
	}
      return 41;
    }
  char *name_AS = _("AS");
  if (len >= strlen (name_AS)
      && strncmp (text, name_AS, strlen (name_AS)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_AS);
	}
      return 42;
    }
  char *name_2S = _("2S");
  if (len >= strlen (name_2S)
      && strncmp (text, name_2S, strlen (name_2S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_2S);
	}
      return 43;
    }
  char *name_3S = _("3S");
  if (len >= strlen (name_3S)
      && strncmp (text, name_3S, strlen (name_3S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_3S);
	}
      return 44;
    }
  char *name_4S = _("4S");
  if (len >= strlen (name_4S)
      && strncmp (text, name_4S, strlen (name_4S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_4S);
	}
      return 45;
    }
  char *name_5S = _("5S");
  if (len >= strlen (name_5S)
      && strncmp (text, name_5S, strlen (name_5S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_5S);
	}
      return 46;
    }
  char *name_6S = _("6S");
  if (len >= strlen (name_6S)
      && strncmp (text, name_6S, strlen (name_6S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_6S);
	}
      return 47;
    }
  char *name_7S = _("7S");
  if (len >= strlen (name_7S)
      && strncmp (text, name_7S, strlen (name_7S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_7S);
	}
      return 48;
    }
  char *name_8S = _("8S");
  if (len >= strlen (name_8S)
      && strncmp (text, name_8S, strlen (name_8S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_8S);
	}
      return 49;
    }
  char *name_9S = _("9S");
  if (len >= strlen (name_9S)
      && strncmp (text, name_9S, strlen (name_9S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_9S);
	}
      return 50;
    }
  char *name_10S = _("10S");
  if (len >= strlen (name_10S)
      && strncmp (text, name_10S, strlen (name_10S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_10S);
	}
      return 51;
    }
  char *name_JS = _("JS");
  if (len >= strlen (name_JS)
      && strncmp (text, name_JS, strlen (name_JS)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_JS);
	}
      return 52;
    }
  char *name_CS = _("CS");
  if (len >= strlen (name_CS)
      && strncmp (text, name_CS, strlen (name_CS)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_CS);
	}
      return 53;
    }
  char *name_QS = _("QS");
  if (len >= strlen (name_QS)
      && strncmp (text, name_QS, strlen (name_QS)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_QS);
	}
      return 54;
    }
  char *name_KS = _("KS");
  if (len >= strlen (name_KS)
      && strncmp (text, name_KS, strlen (name_KS)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_KS);
	}
      return 55;
    }
  char *name_1T = _("1T");
  if (len >= strlen (name_1T)
      && strncmp (text, name_1T, strlen (name_1T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_1T);
	}
      return TAROT_PETIT;
    }
  char *name_2T = _("2T");
  if (len >= strlen (name_2T)
      && strncmp (text, name_2T, strlen (name_2T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_2T);
	}
      return 57;
    }
  char *name_3T = _("3T");
  if (len >= strlen (name_3T)
      && strncmp (text, name_3T, strlen (name_3T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_3T);
	}
      return 58;
    }
  char *name_4T = _("4T");
  if (len >= strlen (name_4T)
      && strncmp (text, name_4T, strlen (name_4T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_4T);
	}
      return 59;
    }
  char *name_5T = _("5T");
  if (len >= strlen (name_5T)
      && strncmp (text, name_5T, strlen (name_5T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_5T);
	}
      return 60;
    }
  char *name_6T = _("6T");
  if (len >= strlen (name_6T)
      && strncmp (text, name_6T, strlen (name_6T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_6T);
	}
      return 61;
    }
  char *name_7T = _("7T");
  if (len >= strlen (name_7T)
      && strncmp (text, name_7T, strlen (name_7T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_7T);
	}
      return 62;
    }
  char *name_8T = _("8T");
  if (len >= strlen (name_8T)
      && strncmp (text, name_8T, strlen (name_8T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_8T);
	}
      return 63;
    }
  char *name_9T = _("9T");
  if (len >= strlen (name_9T)
      && strncmp (text, name_9T, strlen (name_9T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_9T);
	}
      return 64;
    }
  char *name_10T = _("10T");
  if (len >= strlen (name_10T)
      && strncmp (text, name_10T, strlen (name_10T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_10T);
	}
      return 65;
    }
  char *name_11T = _("11T");
  if (len >= strlen (name_11T)
      && strncmp (text, name_11T, strlen (name_11T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_11T);
	}
      return 66;
    }
  char *name_12T = _("12T");
  if (len >= strlen (name_12T)
      && strncmp (text, name_12T, strlen (name_12T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_12T);
	}
      return 67;
    }
  char *name_13T = _("13T");
  if (len >= strlen (name_13T)
      && strncmp (text, name_13T, strlen (name_13T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_13T);
	}
      return 68;
    }
  char *name_14T = _("14T");
  if (len >= strlen (name_14T)
      && strncmp (text, name_14T, strlen (name_14T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_14T);
	}
      return 69;
    }
  char *name_15T = _("15T");
  if (len >= strlen (name_15T)
      && strncmp (text, name_15T, strlen (name_15T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_15T);
	}
      return 70;
    }
  char *name_16T = _("16T");
  if (len >= strlen (name_16T)
      && strncmp (text, name_16T, strlen (name_16T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_16T);
	}
      return 71;
    }
  char *name_17T = _("17T");
  if (len >= strlen (name_17T)
      && strncmp (text, name_17T, strlen (name_17T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_17T);
	}
      return 72;
    }
  char *name_18T = _("18T");
  if (len >= strlen (name_18T)
      && strncmp (text, name_18T, strlen (name_18T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_18T);
	}
      return 73;
    }
  char *name_19T = _("19T");
  if (len >= strlen (name_19T)
      && strncmp (text, name_19T, strlen (name_19T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_19T);
	}
      return 74;
    }
  char *name_20T = _("20T");
  if (len >= strlen (name_20T)
      && strncmp (text, name_20T, strlen (name_20T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_20T);
	}
      return 75;
    }
  char *name_21T = _("21T");
  if (len >= strlen (name_21T)
      && strncmp (text, name_21T, strlen (name_21T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_21T);
	}
      return TAROT_TWENTYONE;
    }
  char *name_EXC = _("EXC");
  if (len >= strlen (name_EXC)
      && strncmp (text, name_EXC, strlen (name_EXC)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_EXC);
	}
      return TAROT_EXCUSE;
    }
  if (end)
    {
      *end = (char *) text;
    }
  return (TarotCard) (-1);
}

static inline TarotCard
card_parse_c (const char *text, char **end)
{
  size_t len = strlen (text);
  char *name_AH = "AH";
  if (len >= strlen (name_AH)
      && strncmp (text, name_AH, strlen (name_AH)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_AH);
	}
      return 0;
    }
  char *name_2H = "2H";
  if (len >= strlen (name_2H)
      && strncmp (text, name_2H, strlen (name_2H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_2H);
	}
      return 1;
    }
  char *name_3H = "3H";
  if (len >= strlen (name_3H)
      && strncmp (text, name_3H, strlen (name_3H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_3H);
	}
      return 2;
    }
  char *name_4H = "4H";
  if (len >= strlen (name_4H)
      && strncmp (text, name_4H, strlen (name_4H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_4H);
	}
      return 3;
    }
  char *name_5H = "5H";
  if (len >= strlen (name_5H)
      && strncmp (text, name_5H, strlen (name_5H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_5H);
	}
      return 4;
    }
  char *name_6H = "6H";
  if (len >= strlen (name_6H)
      && strncmp (text, name_6H, strlen (name_6H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_6H);
	}
      return 5;
    }
  char *name_7H = "7H";
  if (len >= strlen (name_7H)
      && strncmp (text, name_7H, strlen (name_7H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_7H);
	}
      return 6;
    }
  char *name_8H = "8H";
  if (len >= strlen (name_8H)
      && strncmp (text, name_8H, strlen (name_8H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_8H);
	}
      return 7;
    }
  char *name_9H = "9H";
  if (len >= strlen (name_9H)
      && strncmp (text, name_9H, strlen (name_9H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_9H);
	}
      return 8;
    }
  char *name_10H = "10H";
  if (len >= strlen (name_10H)
      && strncmp (text, name_10H, strlen (name_10H)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_10H);
	}
      return 9;
    }
  char *name_JH = "JH";
  if (len >= strlen (name_JH)
      && strncmp (text, name_JH, strlen (name_JH)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_JH);
	}
      return 10;
    }
  char *name_CH = "CH";
  if (len >= strlen (name_CH)
      && strncmp (text, name_CH, strlen (name_CH)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_CH);
	}
      return 11;
    }
  char *name_QH = "QH";
  if (len >= strlen (name_QH)
      && strncmp (text, name_QH, strlen (name_QH)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_QH);
	}
      return 12;
    }
  char *name_KH = "KH";
  if (len >= strlen (name_KH)
      && strncmp (text, name_KH, strlen (name_KH)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_KH);
	}
      return 13;
    }
  char *name_AC = "AC";
  if (len >= strlen (name_AC)
      && strncmp (text, name_AC, strlen (name_AC)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_AC);
	}
      return 14;
    }
  char *name_2C = "2C";
  if (len >= strlen (name_2C)
      && strncmp (text, name_2C, strlen (name_2C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_2C);
	}
      return 15;
    }
  char *name_3C = "3C";
  if (len >= strlen (name_3C)
      && strncmp (text, name_3C, strlen (name_3C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_3C);
	}
      return 16;
    }
  char *name_4C = "4C";
  if (len >= strlen (name_4C)
      && strncmp (text, name_4C, strlen (name_4C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_4C);
	}
      return 17;
    }
  char *name_5C = "5C";
  if (len >= strlen (name_5C)
      && strncmp (text, name_5C, strlen (name_5C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_5C);
	}
      return 18;
    }
  char *name_6C = "6C";
  if (len >= strlen (name_6C)
      && strncmp (text, name_6C, strlen (name_6C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_6C);
	}
      return 19;
    }
  char *name_7C = "7C";
  if (len >= strlen (name_7C)
      && strncmp (text, name_7C, strlen (name_7C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_7C);
	}
      return 20;
    }
  char *name_8C = "8C";
  if (len >= strlen (name_8C)
      && strncmp (text, name_8C, strlen (name_8C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_8C);
	}
      return 21;
    }
  char *name_9C = "9C";
  if (len >= strlen (name_9C)
      && strncmp (text, name_9C, strlen (name_9C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_9C);
	}
      return 22;
    }
  char *name_10C = "10C";
  if (len >= strlen (name_10C)
      && strncmp (text, name_10C, strlen (name_10C)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_10C);
	}
      return 23;
    }
  char *name_JC = "JC";
  if (len >= strlen (name_JC)
      && strncmp (text, name_JC, strlen (name_JC)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_JC);
	}
      return 24;
    }
  char *name_CC = "CC";
  if (len >= strlen (name_CC)
      && strncmp (text, name_CC, strlen (name_CC)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_CC);
	}
      return 25;
    }
  char *name_QC = "QC";
  if (len >= strlen (name_QC)
      && strncmp (text, name_QC, strlen (name_QC)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_QC);
	}
      return 26;
    }
  char *name_KC = "KC";
  if (len >= strlen (name_KC)
      && strncmp (text, name_KC, strlen (name_KC)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_KC);
	}
      return 27;
    }
  char *name_AD = "AD";
  if (len >= strlen (name_AD)
      && strncmp (text, name_AD, strlen (name_AD)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_AD);
	}
      return 28;
    }
  char *name_2D = "2D";
  if (len >= strlen (name_2D)
      && strncmp (text, name_2D, strlen (name_2D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_2D);
	}
      return 29;
    }
  char *name_3D = "3D";
  if (len >= strlen (name_3D)
      && strncmp (text, name_3D, strlen (name_3D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_3D);
	}
      return 30;
    }
  char *name_4D = "4D";
  if (len >= strlen (name_4D)
      && strncmp (text, name_4D, strlen (name_4D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_4D);
	}
      return 31;
    }
  char *name_5D = "5D";
  if (len >= strlen (name_5D)
      && strncmp (text, name_5D, strlen (name_5D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_5D);
	}
      return 32;
    }
  char *name_6D = "6D";
  if (len >= strlen (name_6D)
      && strncmp (text, name_6D, strlen (name_6D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_6D);
	}
      return 33;
    }
  char *name_7D = "7D";
  if (len >= strlen (name_7D)
      && strncmp (text, name_7D, strlen (name_7D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_7D);
	}
      return 34;
    }
  char *name_8D = "8D";
  if (len >= strlen (name_8D)
      && strncmp (text, name_8D, strlen (name_8D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_8D);
	}
      return 35;
    }
  char *name_9D = "9D";
  if (len >= strlen (name_9D)
      && strncmp (text, name_9D, strlen (name_9D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_9D);
	}
      return 36;
    }
  char *name_10D = "10D";
  if (len >= strlen (name_10D)
      && strncmp (text, name_10D, strlen (name_10D)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_10D);
	}
      return 37;
    }
  char *name_JD = "JD";
  if (len >= strlen (name_JD)
      && strncmp (text, name_JD, strlen (name_JD)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_JD);
	}
      return 38;
    }
  char *name_CD = "CD";
  if (len >= strlen (name_CD)
      && strncmp (text, name_CD, strlen (name_CD)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_CD);
	}
      return 39;
    }
  char *name_QD = "QD";
  if (len >= strlen (name_QD)
      && strncmp (text, name_QD, strlen (name_QD)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_QD);
	}
      return 40;
    }
  char *name_KD = "KD";
  if (len >= strlen (name_KD)
      && strncmp (text, name_KD, strlen (name_KD)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_KD);
	}
      return 41;
    }
  char *name_AS = "AS";
  if (len >= strlen (name_AS)
      && strncmp (text, name_AS, strlen (name_AS)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_AS);
	}
      return 42;
    }
  char *name_2S = "2S";
  if (len >= strlen (name_2S)
      && strncmp (text, name_2S, strlen (name_2S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_2S);
	}
      return 43;
    }
  char *name_3S = "3S";
  if (len >= strlen (name_3S)
      && strncmp (text, name_3S, strlen (name_3S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_3S);
	}
      return 44;
    }
  char *name_4S = "4S";
  if (len >= strlen (name_4S)
      && strncmp (text, name_4S, strlen (name_4S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_4S);
	}
      return 45;
    }
  char *name_5S = "5S";
  if (len >= strlen (name_5S)
      && strncmp (text, name_5S, strlen (name_5S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_5S);
	}
      return 46;
    }
  char *name_6S = "6S";
  if (len >= strlen (name_6S)
      && strncmp (text, name_6S, strlen (name_6S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_6S);
	}
      return 47;
    }
  char *name_7S = "7S";
  if (len >= strlen (name_7S)
      && strncmp (text, name_7S, strlen (name_7S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_7S);
	}
      return 48;
    }
  char *name_8S = "8S";
  if (len >= strlen (name_8S)
      && strncmp (text, name_8S, strlen (name_8S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_8S);
	}
      return 49;
    }
  char *name_9S = "9S";
  if (len >= strlen (name_9S)
      && strncmp (text, name_9S, strlen (name_9S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_9S);
	}
      return 50;
    }
  char *name_10S = "10S";
  if (len >= strlen (name_10S)
      && strncmp (text, name_10S, strlen (name_10S)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_10S);
	}
      return 51;
    }
  char *name_JS = "JS";
  if (len >= strlen (name_JS)
      && strncmp (text, name_JS, strlen (name_JS)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_JS);
	}
      return 52;
    }
  char *name_CS = "CS";
  if (len >= strlen (name_CS)
      && strncmp (text, name_CS, strlen (name_CS)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_CS);
	}
      return 53;
    }
  char *name_QS = "QS";
  if (len >= strlen (name_QS)
      && strncmp (text, name_QS, strlen (name_QS)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_QS);
	}
      return 54;
    }
  char *name_KS = "KS";
  if (len >= strlen (name_KS)
      && strncmp (text, name_KS, strlen (name_KS)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_KS);
	}
      return 55;
    }
  char *name_1T = "1T";
  if (len >= strlen (name_1T)
      && strncmp (text, name_1T, strlen (name_1T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_1T);
	}
      return TAROT_PETIT;
    }
  char *name_2T = "2T";
  if (len >= strlen (name_2T)
      && strncmp (text, name_2T, strlen (name_2T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_2T);
	}
      return 57;
    }
  char *name_3T = "3T";
  if (len >= strlen (name_3T)
      && strncmp (text, name_3T, strlen (name_3T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_3T);
	}
      return 58;
    }
  char *name_4T = "4T";
  if (len >= strlen (name_4T)
      && strncmp (text, name_4T, strlen (name_4T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_4T);
	}
      return 59;
    }
  char *name_5T = "5T";
  if (len >= strlen (name_5T)
      && strncmp (text, name_5T, strlen (name_5T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_5T);
	}
      return 60;
    }
  char *name_6T = "6T";
  if (len >= strlen (name_6T)
      && strncmp (text, name_6T, strlen (name_6T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_6T);
	}
      return 61;
    }
  char *name_7T = "7T";
  if (len >= strlen (name_7T)
      && strncmp (text, name_7T, strlen (name_7T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_7T);
	}
      return 62;
    }
  char *name_8T = "8T";
  if (len >= strlen (name_8T)
      && strncmp (text, name_8T, strlen (name_8T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_8T);
	}
      return 63;
    }
  char *name_9T = "9T";
  if (len >= strlen (name_9T)
      && strncmp (text, name_9T, strlen (name_9T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_9T);
	}
      return 64;
    }
  char *name_10T = "10T";
  if (len >= strlen (name_10T)
      && strncmp (text, name_10T, strlen (name_10T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_10T);
	}
      return 65;
    }
  char *name_11T = "11T";
  if (len >= strlen (name_11T)
      && strncmp (text, name_11T, strlen (name_11T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_11T);
	}
      return 66;
    }
  char *name_12T = "12T";
  if (len >= strlen (name_12T)
      && strncmp (text, name_12T, strlen (name_12T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_12T);
	}
      return 67;
    }
  char *name_13T = "13T";
  if (len >= strlen (name_13T)
      && strncmp (text, name_13T, strlen (name_13T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_13T);
	}
      return 68;
    }
  char *name_14T = "14T";
  if (len >= strlen (name_14T)
      && strncmp (text, name_14T, strlen (name_14T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_14T);
	}
      return 69;
    }
  char *name_15T = "15T";
  if (len >= strlen (name_15T)
      && strncmp (text, name_15T, strlen (name_15T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_15T);
	}
      return 70;
    }
  char *name_16T = "16T";
  if (len >= strlen (name_16T)
      && strncmp (text, name_16T, strlen (name_16T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_16T);
	}
      return 71;
    }
  char *name_17T = "17T";
  if (len >= strlen (name_17T)
      && strncmp (text, name_17T, strlen (name_17T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_17T);
	}
      return 72;
    }
  char *name_18T = "18T";
  if (len >= strlen (name_18T)
      && strncmp (text, name_18T, strlen (name_18T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_18T);
	}
      return 73;
    }
  char *name_19T = "19T";
  if (len >= strlen (name_19T)
      && strncmp (text, name_19T, strlen (name_19T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_19T);
	}
      return 74;
    }
  char *name_20T = "20T";
  if (len >= strlen (name_20T)
      && strncmp (text, name_20T, strlen (name_20T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_20T);
	}
      return 75;
    }
  char *name_21T = "21T";
  if (len >= strlen (name_21T)
      && strncmp (text, name_21T, strlen (name_21T)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_21T);
	}
      return TAROT_TWENTYONE;
    }
  char *name_EXC = "EXC";
  if (len >= strlen (name_EXC)
      && strncmp (text, name_EXC, strlen (name_EXC)) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (name_EXC);
	}
      return TAROT_EXCUSE;
    }
  if (end)
    {
      *end = (char *) text;
    }
  return (TarotCard) (-1);
}

static inline size_t
card_to_string (TarotCard c, size_t max, char *dest)
{
  char *name_AH = _("AH");
  if (c == 0)
    {
      size_t required = strlen (name_AH);
      if (max > required)
	{
	  strncpy (dest, name_AH, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_AH, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_2H = _("2H");
  if (c == 1)
    {
      size_t required = strlen (name_2H);
      if (max > required)
	{
	  strncpy (dest, name_2H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_2H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_3H = _("3H");
  if (c == 2)
    {
      size_t required = strlen (name_3H);
      if (max > required)
	{
	  strncpy (dest, name_3H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_3H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_4H = _("4H");
  if (c == 3)
    {
      size_t required = strlen (name_4H);
      if (max > required)
	{
	  strncpy (dest, name_4H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_4H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_5H = _("5H");
  if (c == 4)
    {
      size_t required = strlen (name_5H);
      if (max > required)
	{
	  strncpy (dest, name_5H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_5H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_6H = _("6H");
  if (c == 5)
    {
      size_t required = strlen (name_6H);
      if (max > required)
	{
	  strncpy (dest, name_6H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_6H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_7H = _("7H");
  if (c == 6)
    {
      size_t required = strlen (name_7H);
      if (max > required)
	{
	  strncpy (dest, name_7H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_7H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_8H = _("8H");
  if (c == 7)
    {
      size_t required = strlen (name_8H);
      if (max > required)
	{
	  strncpy (dest, name_8H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_8H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_9H = _("9H");
  if (c == 8)
    {
      size_t required = strlen (name_9H);
      if (max > required)
	{
	  strncpy (dest, name_9H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_9H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_10H = _("10H");
  if (c == 9)
    {
      size_t required = strlen (name_10H);
      if (max > required)
	{
	  strncpy (dest, name_10H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_10H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_JH = _("JH");
  if (c == 10)
    {
      size_t required = strlen (name_JH);
      if (max > required)
	{
	  strncpy (dest, name_JH, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_JH, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_CH = _("CH");
  if (c == 11)
    {
      size_t required = strlen (name_CH);
      if (max > required)
	{
	  strncpy (dest, name_CH, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_CH, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_QH = _("QH");
  if (c == 12)
    {
      size_t required = strlen (name_QH);
      if (max > required)
	{
	  strncpy (dest, name_QH, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_QH, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_KH = _("KH");
  if (c == 13)
    {
      size_t required = strlen (name_KH);
      if (max > required)
	{
	  strncpy (dest, name_KH, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_KH, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_AC = _("AC");
  if (c == 14)
    {
      size_t required = strlen (name_AC);
      if (max > required)
	{
	  strncpy (dest, name_AC, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_AC, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_2C = _("2C");
  if (c == 15)
    {
      size_t required = strlen (name_2C);
      if (max > required)
	{
	  strncpy (dest, name_2C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_2C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_3C = _("3C");
  if (c == 16)
    {
      size_t required = strlen (name_3C);
      if (max > required)
	{
	  strncpy (dest, name_3C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_3C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_4C = _("4C");
  if (c == 17)
    {
      size_t required = strlen (name_4C);
      if (max > required)
	{
	  strncpy (dest, name_4C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_4C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_5C = _("5C");
  if (c == 18)
    {
      size_t required = strlen (name_5C);
      if (max > required)
	{
	  strncpy (dest, name_5C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_5C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_6C = _("6C");
  if (c == 19)
    {
      size_t required = strlen (name_6C);
      if (max > required)
	{
	  strncpy (dest, name_6C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_6C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_7C = _("7C");
  if (c == 20)
    {
      size_t required = strlen (name_7C);
      if (max > required)
	{
	  strncpy (dest, name_7C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_7C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_8C = _("8C");
  if (c == 21)
    {
      size_t required = strlen (name_8C);
      if (max > required)
	{
	  strncpy (dest, name_8C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_8C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_9C = _("9C");
  if (c == 22)
    {
      size_t required = strlen (name_9C);
      if (max > required)
	{
	  strncpy (dest, name_9C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_9C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_10C = _("10C");
  if (c == 23)
    {
      size_t required = strlen (name_10C);
      if (max > required)
	{
	  strncpy (dest, name_10C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_10C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_JC = _("JC");
  if (c == 24)
    {
      size_t required = strlen (name_JC);
      if (max > required)
	{
	  strncpy (dest, name_JC, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_JC, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_CC = _("CC");
  if (c == 25)
    {
      size_t required = strlen (name_CC);
      if (max > required)
	{
	  strncpy (dest, name_CC, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_CC, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_QC = _("QC");
  if (c == 26)
    {
      size_t required = strlen (name_QC);
      if (max > required)
	{
	  strncpy (dest, name_QC, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_QC, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_KC = _("KC");
  if (c == 27)
    {
      size_t required = strlen (name_KC);
      if (max > required)
	{
	  strncpy (dest, name_KC, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_KC, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_AD = _("AD");
  if (c == 28)
    {
      size_t required = strlen (name_AD);
      if (max > required)
	{
	  strncpy (dest, name_AD, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_AD, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_2D = _("2D");
  if (c == 29)
    {
      size_t required = strlen (name_2D);
      if (max > required)
	{
	  strncpy (dest, name_2D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_2D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_3D = _("3D");
  if (c == 30)
    {
      size_t required = strlen (name_3D);
      if (max > required)
	{
	  strncpy (dest, name_3D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_3D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_4D = _("4D");
  if (c == 31)
    {
      size_t required = strlen (name_4D);
      if (max > required)
	{
	  strncpy (dest, name_4D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_4D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_5D = _("5D");
  if (c == 32)
    {
      size_t required = strlen (name_5D);
      if (max > required)
	{
	  strncpy (dest, name_5D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_5D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_6D = _("6D");
  if (c == 33)
    {
      size_t required = strlen (name_6D);
      if (max > required)
	{
	  strncpy (dest, name_6D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_6D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_7D = _("7D");
  if (c == 34)
    {
      size_t required = strlen (name_7D);
      if (max > required)
	{
	  strncpy (dest, name_7D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_7D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_8D = _("8D");
  if (c == 35)
    {
      size_t required = strlen (name_8D);
      if (max > required)
	{
	  strncpy (dest, name_8D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_8D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_9D = _("9D");
  if (c == 36)
    {
      size_t required = strlen (name_9D);
      if (max > required)
	{
	  strncpy (dest, name_9D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_9D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_10D = _("10D");
  if (c == 37)
    {
      size_t required = strlen (name_10D);
      if (max > required)
	{
	  strncpy (dest, name_10D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_10D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_JD = _("JD");
  if (c == 38)
    {
      size_t required = strlen (name_JD);
      if (max > required)
	{
	  strncpy (dest, name_JD, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_JD, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_CD = _("CD");
  if (c == 39)
    {
      size_t required = strlen (name_CD);
      if (max > required)
	{
	  strncpy (dest, name_CD, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_CD, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_QD = _("QD");
  if (c == 40)
    {
      size_t required = strlen (name_QD);
      if (max > required)
	{
	  strncpy (dest, name_QD, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_QD, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_KD = _("KD");
  if (c == 41)
    {
      size_t required = strlen (name_KD);
      if (max > required)
	{
	  strncpy (dest, name_KD, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_KD, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_AS = _("AS");
  if (c == 42)
    {
      size_t required = strlen (name_AS);
      if (max > required)
	{
	  strncpy (dest, name_AS, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_AS, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_2S = _("2S");
  if (c == 43)
    {
      size_t required = strlen (name_2S);
      if (max > required)
	{
	  strncpy (dest, name_2S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_2S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_3S = _("3S");
  if (c == 44)
    {
      size_t required = strlen (name_3S);
      if (max > required)
	{
	  strncpy (dest, name_3S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_3S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_4S = _("4S");
  if (c == 45)
    {
      size_t required = strlen (name_4S);
      if (max > required)
	{
	  strncpy (dest, name_4S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_4S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_5S = _("5S");
  if (c == 46)
    {
      size_t required = strlen (name_5S);
      if (max > required)
	{
	  strncpy (dest, name_5S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_5S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_6S = _("6S");
  if (c == 47)
    {
      size_t required = strlen (name_6S);
      if (max > required)
	{
	  strncpy (dest, name_6S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_6S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_7S = _("7S");
  if (c == 48)
    {
      size_t required = strlen (name_7S);
      if (max > required)
	{
	  strncpy (dest, name_7S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_7S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_8S = _("8S");
  if (c == 49)
    {
      size_t required = strlen (name_8S);
      if (max > required)
	{
	  strncpy (dest, name_8S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_8S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_9S = _("9S");
  if (c == 50)
    {
      size_t required = strlen (name_9S);
      if (max > required)
	{
	  strncpy (dest, name_9S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_9S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_10S = _("10S");
  if (c == 51)
    {
      size_t required = strlen (name_10S);
      if (max > required)
	{
	  strncpy (dest, name_10S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_10S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_JS = _("JS");
  if (c == 52)
    {
      size_t required = strlen (name_JS);
      if (max > required)
	{
	  strncpy (dest, name_JS, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_JS, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_CS = _("CS");
  if (c == 53)
    {
      size_t required = strlen (name_CS);
      if (max > required)
	{
	  strncpy (dest, name_CS, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_CS, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_QS = _("QS");
  if (c == 54)
    {
      size_t required = strlen (name_QS);
      if (max > required)
	{
	  strncpy (dest, name_QS, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_QS, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_KS = _("KS");
  if (c == 55)
    {
      size_t required = strlen (name_KS);
      if (max > required)
	{
	  strncpy (dest, name_KS, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_KS, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_1T = _("1T");
  if (c == TAROT_PETIT)
    {
      size_t required = strlen (name_1T);
      if (max > required)
	{
	  strncpy (dest, name_1T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_1T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_2T = _("2T");
  if (c == 57)
    {
      size_t required = strlen (name_2T);
      if (max > required)
	{
	  strncpy (dest, name_2T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_2T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_3T = _("3T");
  if (c == 58)
    {
      size_t required = strlen (name_3T);
      if (max > required)
	{
	  strncpy (dest, name_3T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_3T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_4T = _("4T");
  if (c == 59)
    {
      size_t required = strlen (name_4T);
      if (max > required)
	{
	  strncpy (dest, name_4T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_4T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_5T = _("5T");
  if (c == 60)
    {
      size_t required = strlen (name_5T);
      if (max > required)
	{
	  strncpy (dest, name_5T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_5T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_6T = _("6T");
  if (c == 61)
    {
      size_t required = strlen (name_6T);
      if (max > required)
	{
	  strncpy (dest, name_6T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_6T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_7T = _("7T");
  if (c == 62)
    {
      size_t required = strlen (name_7T);
      if (max > required)
	{
	  strncpy (dest, name_7T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_7T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_8T = _("8T");
  if (c == 63)
    {
      size_t required = strlen (name_8T);
      if (max > required)
	{
	  strncpy (dest, name_8T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_8T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_9T = _("9T");
  if (c == 64)
    {
      size_t required = strlen (name_9T);
      if (max > required)
	{
	  strncpy (dest, name_9T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_9T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_10T = _("10T");
  if (c == 65)
    {
      size_t required = strlen (name_10T);
      if (max > required)
	{
	  strncpy (dest, name_10T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_10T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_11T = _("11T");
  if (c == 66)
    {
      size_t required = strlen (name_11T);
      if (max > required)
	{
	  strncpy (dest, name_11T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_11T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_12T = _("12T");
  if (c == 67)
    {
      size_t required = strlen (name_12T);
      if (max > required)
	{
	  strncpy (dest, name_12T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_12T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_13T = _("13T");
  if (c == 68)
    {
      size_t required = strlen (name_13T);
      if (max > required)
	{
	  strncpy (dest, name_13T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_13T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_14T = _("14T");
  if (c == 69)
    {
      size_t required = strlen (name_14T);
      if (max > required)
	{
	  strncpy (dest, name_14T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_14T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_15T = _("15T");
  if (c == 70)
    {
      size_t required = strlen (name_15T);
      if (max > required)
	{
	  strncpy (dest, name_15T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_15T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_16T = _("16T");
  if (c == 71)
    {
      size_t required = strlen (name_16T);
      if (max > required)
	{
	  strncpy (dest, name_16T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_16T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_17T = _("17T");
  if (c == 72)
    {
      size_t required = strlen (name_17T);
      if (max > required)
	{
	  strncpy (dest, name_17T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_17T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_18T = _("18T");
  if (c == 73)
    {
      size_t required = strlen (name_18T);
      if (max > required)
	{
	  strncpy (dest, name_18T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_18T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_19T = _("19T");
  if (c == 74)
    {
      size_t required = strlen (name_19T);
      if (max > required)
	{
	  strncpy (dest, name_19T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_19T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_20T = _("20T");
  if (c == 75)
    {
      size_t required = strlen (name_20T);
      if (max > required)
	{
	  strncpy (dest, name_20T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_20T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_21T = _("21T");
  if (c == TAROT_TWENTYONE)
    {
      size_t required = strlen (name_21T);
      if (max > required)
	{
	  strncpy (dest, name_21T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_21T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_EXC = _("EXC");
  if (c == TAROT_EXCUSE)
    {
      size_t required = strlen (name_EXC);
      if (max > required)
	{
	  strncpy (dest, name_EXC, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_EXC, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  if (max != 0)
    {
      dest[0] = '\0';
    }
  return 0;
}

static inline size_t
card_to_string_c (TarotCard c, size_t max, char *dest)
{
  char *name_AH = "AH";
  if (c == 0)
    {
      size_t required = strlen (name_AH);
      if (max > required)
	{
	  strncpy (dest, name_AH, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_AH, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_2H = "2H";
  if (c == 1)
    {
      size_t required = strlen (name_2H);
      if (max > required)
	{
	  strncpy (dest, name_2H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_2H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_3H = "3H";
  if (c == 2)
    {
      size_t required = strlen (name_3H);
      if (max > required)
	{
	  strncpy (dest, name_3H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_3H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_4H = "4H";
  if (c == 3)
    {
      size_t required = strlen (name_4H);
      if (max > required)
	{
	  strncpy (dest, name_4H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_4H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_5H = "5H";
  if (c == 4)
    {
      size_t required = strlen (name_5H);
      if (max > required)
	{
	  strncpy (dest, name_5H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_5H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_6H = "6H";
  if (c == 5)
    {
      size_t required = strlen (name_6H);
      if (max > required)
	{
	  strncpy (dest, name_6H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_6H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_7H = "7H";
  if (c == 6)
    {
      size_t required = strlen (name_7H);
      if (max > required)
	{
	  strncpy (dest, name_7H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_7H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_8H = "8H";
  if (c == 7)
    {
      size_t required = strlen (name_8H);
      if (max > required)
	{
	  strncpy (dest, name_8H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_8H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_9H = "9H";
  if (c == 8)
    {
      size_t required = strlen (name_9H);
      if (max > required)
	{
	  strncpy (dest, name_9H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_9H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_10H = "10H";
  if (c == 9)
    {
      size_t required = strlen (name_10H);
      if (max > required)
	{
	  strncpy (dest, name_10H, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_10H, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_JH = "JH";
  if (c == 10)
    {
      size_t required = strlen (name_JH);
      if (max > required)
	{
	  strncpy (dest, name_JH, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_JH, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_CH = "CH";
  if (c == 11)
    {
      size_t required = strlen (name_CH);
      if (max > required)
	{
	  strncpy (dest, name_CH, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_CH, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_QH = "QH";
  if (c == 12)
    {
      size_t required = strlen (name_QH);
      if (max > required)
	{
	  strncpy (dest, name_QH, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_QH, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_KH = "KH";
  if (c == 13)
    {
      size_t required = strlen (name_KH);
      if (max > required)
	{
	  strncpy (dest, name_KH, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_KH, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_AC = "AC";
  if (c == 14)
    {
      size_t required = strlen (name_AC);
      if (max > required)
	{
	  strncpy (dest, name_AC, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_AC, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_2C = "2C";
  if (c == 15)
    {
      size_t required = strlen (name_2C);
      if (max > required)
	{
	  strncpy (dest, name_2C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_2C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_3C = "3C";
  if (c == 16)
    {
      size_t required = strlen (name_3C);
      if (max > required)
	{
	  strncpy (dest, name_3C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_3C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_4C = "4C";
  if (c == 17)
    {
      size_t required = strlen (name_4C);
      if (max > required)
	{
	  strncpy (dest, name_4C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_4C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_5C = "5C";
  if (c == 18)
    {
      size_t required = strlen (name_5C);
      if (max > required)
	{
	  strncpy (dest, name_5C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_5C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_6C = "6C";
  if (c == 19)
    {
      size_t required = strlen (name_6C);
      if (max > required)
	{
	  strncpy (dest, name_6C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_6C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_7C = "7C";
  if (c == 20)
    {
      size_t required = strlen (name_7C);
      if (max > required)
	{
	  strncpy (dest, name_7C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_7C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_8C = "8C";
  if (c == 21)
    {
      size_t required = strlen (name_8C);
      if (max > required)
	{
	  strncpy (dest, name_8C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_8C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_9C = "9C";
  if (c == 22)
    {
      size_t required = strlen (name_9C);
      if (max > required)
	{
	  strncpy (dest, name_9C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_9C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_10C = "10C";
  if (c == 23)
    {
      size_t required = strlen (name_10C);
      if (max > required)
	{
	  strncpy (dest, name_10C, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_10C, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_JC = "JC";
  if (c == 24)
    {
      size_t required = strlen (name_JC);
      if (max > required)
	{
	  strncpy (dest, name_JC, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_JC, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_CC = "CC";
  if (c == 25)
    {
      size_t required = strlen (name_CC);
      if (max > required)
	{
	  strncpy (dest, name_CC, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_CC, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_QC = "QC";
  if (c == 26)
    {
      size_t required = strlen (name_QC);
      if (max > required)
	{
	  strncpy (dest, name_QC, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_QC, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_KC = "KC";
  if (c == 27)
    {
      size_t required = strlen (name_KC);
      if (max > required)
	{
	  strncpy (dest, name_KC, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_KC, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_AD = "AD";
  if (c == 28)
    {
      size_t required = strlen (name_AD);
      if (max > required)
	{
	  strncpy (dest, name_AD, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_AD, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_2D = "2D";
  if (c == 29)
    {
      size_t required = strlen (name_2D);
      if (max > required)
	{
	  strncpy (dest, name_2D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_2D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_3D = "3D";
  if (c == 30)
    {
      size_t required = strlen (name_3D);
      if (max > required)
	{
	  strncpy (dest, name_3D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_3D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_4D = "4D";
  if (c == 31)
    {
      size_t required = strlen (name_4D);
      if (max > required)
	{
	  strncpy (dest, name_4D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_4D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_5D = "5D";
  if (c == 32)
    {
      size_t required = strlen (name_5D);
      if (max > required)
	{
	  strncpy (dest, name_5D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_5D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_6D = "6D";
  if (c == 33)
    {
      size_t required = strlen (name_6D);
      if (max > required)
	{
	  strncpy (dest, name_6D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_6D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_7D = "7D";
  if (c == 34)
    {
      size_t required = strlen (name_7D);
      if (max > required)
	{
	  strncpy (dest, name_7D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_7D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_8D = "8D";
  if (c == 35)
    {
      size_t required = strlen (name_8D);
      if (max > required)
	{
	  strncpy (dest, name_8D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_8D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_9D = "9D";
  if (c == 36)
    {
      size_t required = strlen (name_9D);
      if (max > required)
	{
	  strncpy (dest, name_9D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_9D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_10D = "10D";
  if (c == 37)
    {
      size_t required = strlen (name_10D);
      if (max > required)
	{
	  strncpy (dest, name_10D, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_10D, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_JD = "JD";
  if (c == 38)
    {
      size_t required = strlen (name_JD);
      if (max > required)
	{
	  strncpy (dest, name_JD, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_JD, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_CD = "CD";
  if (c == 39)
    {
      size_t required = strlen (name_CD);
      if (max > required)
	{
	  strncpy (dest, name_CD, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_CD, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_QD = "QD";
  if (c == 40)
    {
      size_t required = strlen (name_QD);
      if (max > required)
	{
	  strncpy (dest, name_QD, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_QD, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_KD = "KD";
  if (c == 41)
    {
      size_t required = strlen (name_KD);
      if (max > required)
	{
	  strncpy (dest, name_KD, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_KD, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_AS = "AS";
  if (c == 42)
    {
      size_t required = strlen (name_AS);
      if (max > required)
	{
	  strncpy (dest, name_AS, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_AS, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_2S = "2S";
  if (c == 43)
    {
      size_t required = strlen (name_2S);
      if (max > required)
	{
	  strncpy (dest, name_2S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_2S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_3S = "3S";
  if (c == 44)
    {
      size_t required = strlen (name_3S);
      if (max > required)
	{
	  strncpy (dest, name_3S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_3S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_4S = "4S";
  if (c == 45)
    {
      size_t required = strlen (name_4S);
      if (max > required)
	{
	  strncpy (dest, name_4S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_4S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_5S = "5S";
  if (c == 46)
    {
      size_t required = strlen (name_5S);
      if (max > required)
	{
	  strncpy (dest, name_5S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_5S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_6S = "6S";
  if (c == 47)
    {
      size_t required = strlen (name_6S);
      if (max > required)
	{
	  strncpy (dest, name_6S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_6S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_7S = "7S";
  if (c == 48)
    {
      size_t required = strlen (name_7S);
      if (max > required)
	{
	  strncpy (dest, name_7S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_7S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_8S = "8S";
  if (c == 49)
    {
      size_t required = strlen (name_8S);
      if (max > required)
	{
	  strncpy (dest, name_8S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_8S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_9S = "9S";
  if (c == 50)
    {
      size_t required = strlen (name_9S);
      if (max > required)
	{
	  strncpy (dest, name_9S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_9S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_10S = "10S";
  if (c == 51)
    {
      size_t required = strlen (name_10S);
      if (max > required)
	{
	  strncpy (dest, name_10S, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_10S, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_JS = "JS";
  if (c == 52)
    {
      size_t required = strlen (name_JS);
      if (max > required)
	{
	  strncpy (dest, name_JS, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_JS, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_CS = "CS";
  if (c == 53)
    {
      size_t required = strlen (name_CS);
      if (max > required)
	{
	  strncpy (dest, name_CS, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_CS, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_QS = "QS";
  if (c == 54)
    {
      size_t required = strlen (name_QS);
      if (max > required)
	{
	  strncpy (dest, name_QS, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_QS, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_KS = "KS";
  if (c == 55)
    {
      size_t required = strlen (name_KS);
      if (max > required)
	{
	  strncpy (dest, name_KS, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_KS, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_1T = "1T";
  if (c == TAROT_PETIT)
    {
      size_t required = strlen (name_1T);
      if (max > required)
	{
	  strncpy (dest, name_1T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_1T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_2T = "2T";
  if (c == 57)
    {
      size_t required = strlen (name_2T);
      if (max > required)
	{
	  strncpy (dest, name_2T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_2T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_3T = "3T";
  if (c == 58)
    {
      size_t required = strlen (name_3T);
      if (max > required)
	{
	  strncpy (dest, name_3T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_3T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_4T = "4T";
  if (c == 59)
    {
      size_t required = strlen (name_4T);
      if (max > required)
	{
	  strncpy (dest, name_4T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_4T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_5T = "5T";
  if (c == 60)
    {
      size_t required = strlen (name_5T);
      if (max > required)
	{
	  strncpy (dest, name_5T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_5T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_6T = "6T";
  if (c == 61)
    {
      size_t required = strlen (name_6T);
      if (max > required)
	{
	  strncpy (dest, name_6T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_6T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_7T = "7T";
  if (c == 62)
    {
      size_t required = strlen (name_7T);
      if (max > required)
	{
	  strncpy (dest, name_7T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_7T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_8T = "8T";
  if (c == 63)
    {
      size_t required = strlen (name_8T);
      if (max > required)
	{
	  strncpy (dest, name_8T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_8T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_9T = "9T";
  if (c == 64)
    {
      size_t required = strlen (name_9T);
      if (max > required)
	{
	  strncpy (dest, name_9T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_9T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_10T = "10T";
  if (c == 65)
    {
      size_t required = strlen (name_10T);
      if (max > required)
	{
	  strncpy (dest, name_10T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_10T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_11T = "11T";
  if (c == 66)
    {
      size_t required = strlen (name_11T);
      if (max > required)
	{
	  strncpy (dest, name_11T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_11T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_12T = "12T";
  if (c == 67)
    {
      size_t required = strlen (name_12T);
      if (max > required)
	{
	  strncpy (dest, name_12T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_12T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_13T = "13T";
  if (c == 68)
    {
      size_t required = strlen (name_13T);
      if (max > required)
	{
	  strncpy (dest, name_13T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_13T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_14T = "14T";
  if (c == 69)
    {
      size_t required = strlen (name_14T);
      if (max > required)
	{
	  strncpy (dest, name_14T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_14T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_15T = "15T";
  if (c == 70)
    {
      size_t required = strlen (name_15T);
      if (max > required)
	{
	  strncpy (dest, name_15T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_15T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_16T = "16T";
  if (c == 71)
    {
      size_t required = strlen (name_16T);
      if (max > required)
	{
	  strncpy (dest, name_16T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_16T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_17T = "17T";
  if (c == 72)
    {
      size_t required = strlen (name_17T);
      if (max > required)
	{
	  strncpy (dest, name_17T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_17T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_18T = "18T";
  if (c == 73)
    {
      size_t required = strlen (name_18T);
      if (max > required)
	{
	  strncpy (dest, name_18T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_18T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_19T = "19T";
  if (c == 74)
    {
      size_t required = strlen (name_19T);
      if (max > required)
	{
	  strncpy (dest, name_19T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_19T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_20T = "20T";
  if (c == 75)
    {
      size_t required = strlen (name_20T);
      if (max > required)
	{
	  strncpy (dest, name_20T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_20T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_21T = "21T";
  if (c == TAROT_TWENTYONE)
    {
      size_t required = strlen (name_21T);
      if (max > required)
	{
	  strncpy (dest, name_21T, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_21T, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  char *name_EXC = "EXC";
  if (c == TAROT_EXCUSE)
    {
      size_t required = strlen (name_EXC);
      if (max > required)
	{
	  strncpy (dest, name_EXC, required);
	  dest[required] = '\0';
	}
      else if (max != 0)
	{
	  strncpy (dest, name_EXC, max - 1);
	  dest[max - 1] = '\0';
	}
      return required;
    }
  if (max != 0)
    {
      dest[0] = '\0';
    }
  return 0;
}

#endif /* not H_TAROT_CARDS_PRIVATE_IMPL_INCLUDED */
